package resolver

// This file will be automatically regenerated based on the schema, any resolver implementations
// will be copied through when generating and any unknown code will be moved to the end.
// Code generated by github.com/99designs/gqlgen version v0.17.40

import (
	"context"
	"fmt"

	"github.com/google/uuid"
	_map "gitlab.com/talgat.s/belka-go/graph/map"
	"gitlab.com/talgat.s/belka-go/graph/model"
	"gitlab.com/talgat.s/belka-go/internal/game"
	"gitlab.com/talgat.s/belka-go/pkg/utils"
)

// CreateGame is the resolver for the createGame field.
func (r *mutationResolver) CreateGame(ctx context.Context) (*model.Game, error) {
	// TODO: move some parts to Redis
	r.Log.InfoContext(ctx, "start mutation CreateGame")

	sub := game.NewSubscriber()

	pub := game.NewPublisher()
	pub.SetMove(make(chan game.Card))

	opt := &game.Options{AfterDraw: game.DrawMultiplyByTwo, ReliablePoints: game.ReliablePoints31}

	team1 := game.NewTeam(uuid.New())
	team2 := game.NewTeam(uuid.New())

	player1 := game.NewUser(uuid.New(), "Jerry Seinfeld")
	player2 := game.NewUser(uuid.New(), "George Costanza")
	player3 := game.NewUser(uuid.New(), "John \"J.D.\" Dorian")
	player4 := game.NewUser(uuid.New(), "Christopher Turk")

	team1.AssignMembers([game.NumPlayersPerTeam]game.Player{player1, player2})
	team2.AssignMembers([game.NumPlayersPerTeam]game.Player{player3, player4})

	ts := game.NewTeams(team1, team2)

	g := game.NewGame(pub, sub, opt, ts)

	r.Games[g.GetID().String()] = g

	return _map.GameGameToGame(g), nil
}

// StartGame is the resolver for the startGame field.
func (r *mutationResolver) StartGame(ctx context.Context, gameID string) (*model.SuccessMessage, error) {
	r.Log.InfoContext(ctx, "start mutation StartGame", "gameID", gameID)

	go func() {
		if r.Games[gameID] != nil {
			if err := r.Games[gameID].Start(); err != nil {
				r.Log.ErrorContext(ctx, "fail mutation StartGame", "error", err)
			}
		} else {
			r.Log.ErrorContext(
				ctx,
				"fail mutation StartGame",
				"error", fmt.Sprintf("game with id: %s currently unavailable", gameID),
			)
		}
	}()

	r.Log.InfoContext(ctx, "success mutation StartGame")

	return &model.SuccessMessage{Success: utils.ToPtr(true)}, nil
}

// Move is the resolver for the move field.
func (r *mutationResolver) Move(ctx context.Context, gameID string, card *model.InputCard) (*model.SuccessMessage, error) {
	r.Log.InfoContext(ctx, "start mutation StartGame", "gameID", gameID, "card", card)

	r.Games[gameID].GetPub().GetMove() <- _map.InputCardToGameCard(card)

	r.Log.InfoContext(ctx, "success mutation StartGame")

	return &model.SuccessMessage{Success: utils.ToPtr(true)}, nil
}
